mostly profanity and fixes
[distro-setup] / brc2
diff --git a/brc2 b/brc2
index 50ca303938b74a63aa395538d240cb5271a48dcd..bad1194baf610135693989e4eb8da56efee403de 100644 (file)
--- a/brc2
+++ b/brc2
@@ -289,11 +289,41 @@ tback() {
 # sshfs example:
 # s sshfs bu@$host:/bu/home/md /bu/mnt -o reconnect,ServerAliveInterval=20,ServerAliveCountMax=30 -o allow_other
 
+edelayoff() {
+  echo all >/etc/exim4/no-delay-eximids
+}
+edelayon() {
+  echo >/etc/exim4/no-delay-eximids
+}
+
 eqgo() {
-  enn -M "$(exiqgrep -i -r.\*)"
+  local -a array tmpstr delayon
+  delayon=true
+  if grep -qFx all /etc/exim4/no-delay-eximids; then
+    delayon=false
+  fi
+  if $delayon; then
+    echo all >/etc/exim4/no-delay-eximids
+  fi
+  tmpstr=$(exiqgrep -i -r.\*)
+  mapfile -t array <<<"$tmpstr"
+  enn -M "${array[@]}"
+  if $delayon; then
+    echo >/etc/exim4/no-delay-eximids
+  fi
 }
 eqgo1() {
-  enn -M "$(exipick -i -r.\*|h1)"
+  local eid
+  eid="$(exipick -i -r.\*|h1)"
+  sed -n "/^all$/p;\$a $eid" /etc/exim4/no-delay-eximids
+  enn -M "$eid"
+}
+ennm() {
+  local eid
+  for eid; do
+    printf "%s\n" "$eid" >>/etc/exim4/no-delay-eximids
+  done
+  enn -M "$@"
 }
 
 
@@ -349,7 +379,7 @@ alerts() {
 ralerts() { # remote alerts
   local ret shell
   # this list is duplicated in check-remote-mailqs
-  for h in bk je li frodo kwwg x3wg x2wg kdwg sywg; do
+  for h in bk je li frodo x3wg kdwg sywg; do
     echo $h:
     shell="ssh $h"
     if [[ $HOSTNAME == "${h%wg}" ]]; then
@@ -387,24 +417,49 @@ astudio() {
   /a/opt/android-studio/bin/studio.sh "$@" & r
 }
 
-# convert brains path to url
-# /f/brains/sysadmin/interns/2022/nick_shrader/intro_blog_post.mdwn
-# becomes
-# https://brains.fsf.org/wiki/sysadmin/interns/2022/nick_shrader/intro_blog_post
-iki() {
-  local url path
+# Convert brains file path to url and vice versa
+# usage: brains [URL_OR_PATH]
+brains() {
+  _iki-convert '(/a)?/f/brains' brains.fsf.org/wiki "$@"
+}
+glue() {
+  _iki-convert '(/a)?/f/gluestick' gluestick.office.fsf.org "$@"
+}
+
+# usage: $0 REPO_PATH [URL_OR_PATH]
+_iki-convert() {
+  local url prefix path input err repo_dir dir url_dir url
+  repo_dir="$1"
+  prefix="$2"
+  shift 2
+  err=false
+  if $err; then
+    return 1
+  fi
   if [[ $1 ]]; then
-    path="$*"
+    input="$*"
   else
-    read -r -p "enter path" path
+    read -r -p "enter path or url"$'\n' input
   fi
-  url=$(readlink -f "$path")
-  url="https://brains.fsf.org/wiki/${url#*brains/}"
-  url="${url%.mdwn}"
-  echo "$url"
-
+  case $input in
+    http*)
+      path="$repo_dir/${input##http*://"$prefix"/}"
+      if [[ $path == */ ]]; then
+        path=${path%/}.mdwn
+      fi
+      j printf "%s\n" "$path"
+      ;;
+    *)
+      path=$(fp "$input")
+      url_dir=$(echo "$path" | sed -r "s,^$repo_dir/,,")
+      url="https://$prefix/$url_dir"
+      url="${url%.mdwn}/"
+      j echo "$url"
+      ;;
+  esac
 }
 
+
 # Generate beet smartplaylists for navidrome.
 # for going in the reverse direction, run
 # /b/ds/navidrome-playlist-export
@@ -525,42 +580,182 @@ EOF
 
 # beet playlist. use beetag with a playlist name
 bpl() {
-  eval beetag "${bpla[$1]}"
+  local playlist playlist_regex
+  case $1 in
+    -h|--help)
+      for playlist in "${!bpla[@]}"; do
+        printf "%s\n" "$playlist"
+      done
+      return 0
+      ;;
+  esac
+
+  playlist="${*: -1}"
+  playlist_regex='[a-z0-9_]'
+  if [[ ! $playlist =~ $playlist_regex ]]; then
+    echo "bpl: error unexpected chars in playlist: $playlist"
+    return 1
+  fi
+  # all but last arg as options
+  eval beetag -r "${*:1:$# - 1}" "${bpla[$playlist]}"
 }
 complete -W "${!bpla[*]}" bpl
 
 
+# beet modify quietly
+beetmq() {
+  local tmpf
+  tmpf="$(mktemp)"
+  # a bunch of effort to ignore output we dont care about...
+  sed 's/^format_item:.*/format_item: ignore_this/' ~/.config/beets/config.yaml >$tmpf
+  beet -c $tmpf modify -y "$@" > >(grep -vFx -e 'ignore_this' -e 'Modifying 1 items.' ||:)
+  rm "$tmpf"
+  beetag-nostatus 1
+}
+
+kill-bg-quiet() {
+  # https://stackoverflow.com/a/5722874
+  kill %% 2>/dev/null ||:; wait %% 2>/dev/null ||:
+}
+
+# debug variables
+dv() {
+  for arg; do
+    printf "%s=%s " "$arg" "${!arg}"
+  done
+  echo
+}
+
+# Must be called from beetag for variables to be setup
+beetag-help() {
+  local -i i j col_total row col button_total row_total remainder_cols remainder_term
+  col_total=4
+  button_total=${#button_map[@]}
+  row_total=$(( button_total / col_total ))
+  remainder_cols=$(( button_total % col_total ))
+  # for debugging
+  #dv button_total row_total remainder_cols
+  beetag-nostatus
+  #   - 3 is just a constant that helps things work in practice.
+  if [[ $LINES ]] && (( LINES - 3 < scrolled )); then
+    hr
+    for (( i=0; i<button_total; i++)); do
+      row=$(( i / col_total ))
+      col=$(( i % col_total ))
+      remainder_term=$remainder_cols
+      if (( col < remainder_term )); then
+        remainder_term=$col
+      fi
+      j=$(( col * row_total + row + remainder_term ))
+      # avoid double newline when we have exactly row * col buttons
+      if (( i == button_total - 1 )); then
+        printf "%s %s" ${buttons[j]} ${button_map[j]}
+      elif (( i % col_total == col_total -1 )); then
+        printf "%s %s\n" ${buttons[j]} ${button_map[j]}
+      else
+        printf "%s %-15s" ${buttons[j]} ${button_map[j]}
+      fi
+    done
+    cat <<'EOF'
+
+
+y other genres   z fg player      ' = toggle play  1-5 rate    ] repeat1
+; previous       _ = delete       up/down skip     mpv vol,pause,seek
+EOF
+    hr
+    scrolled=10
+  fi
+}
+
+# Must be called from beetag for variables to be setup
+beetag-nostatus() {
+  if (( $# )); then
+    scrolled=$(( scrolled + $1 ))
+  fi
+  if $erasable_line; then
+    # https://stackoverflow.com/a/71286261
+    printf '\033[1A\033[K'
+  fi
+  erasable_line=false
+}
+# meant to be called from beetag
+beetag-status() {
+  if $erasable_line; then
+    # https://stackoverflow.com/a/71286261
+    printf '\033[1A\033[K'
+  fi
+  erasable_line=true
+}
+
+# meant to be called from beetag
+mpvrpc() {
+  if jobs -p | grep -q . &>/dev/null; then
+    printf "%s\n" "$*" | socat - /tmp/mpvsock >/dev/null ||:
+  fi
+}
+# meant to be called from beetag
+# o for get output
+mpvrpco() {
+  # note: testing for background jobs will output nothing if we are in a pipeline
+  printf "%s\n" "$*" | socat - /tmp/mpvsock ||:
+}
+
+# meant to be called from beetag
+mpvrpc-percent-pos() {
+  mpvrpco '{ "command": ["get_property", "percent-pos"] }' | jq .data | sed 's/\..*/%/' 2>/dev/null ||:
+}
+
 # tag with beets.
-# usage: beetag QUERY
+# usage: beetag [-r] [-s] QUERY
 # it lists the query, reads an input char for tagging one by one.
-# 1-5 = set rating
-# a-x 0 6-9 / . , = set genre/playlist. (available buttons: ` \ ) ] [
-# q = quit
-# y = toggle to setting rare genres
-# z = put the player in the foreground
-# enter = next song
-# ' = toggle playing of songs, also replays current song if hit twice
-# ; = go to previous song
-# _ = delete file, remove from library
-# -/+ = decrease / increase volume
 #
 # note, you may want to change the play command for doing rapid taging
 # by immediately jumping forward into the song. this is set in the beets
 # config yaml.
+#
+# (available buttons: ` \ ) ] [ and non-printing chars, see
+# https://stackoverflow.com/questions/10679188/casing-arrow-keys-in-bash
+#
+#
+# note: after foregrounding the player, must quit it to get back. can't ctrl-c.
+#
+# keys I dont need help to remember:
+# 1-5 rate
+# q quit
+# ret next
+#
 beetag() {
-  local last_genre_i fstring tag id char new_item char_i genre tag remove doplay i j random
-  local do_rare_genres read_wait
-  local -a pl_tags buttons button_map ids tags rare_genres tmp_tags
+  local last_genre_i fstring tag id char new_item char_i genre tag remove doplay i j random path
+  local do_rare_genres read_wait help line lsout tmp ls_line skip_lookback
+  local escape_char escaped_input expected_input skip_input_regex right_pad erasable_line seek_sec
+  local pl_state_path pl_state_dir pl_state_file tmpstr
+  local new_random pl_seed_path seed_num seed_file fmt first_play repeat1
+  local -a buttons button_map ids tags tmp_tags initial_ls ls_lines paths
   local -A button_i
-  local -i volume
+  local -i i j volume scrolled id_count line_int skip_start pre_j_count head_count skip_lookback
+  local -i overflow_lines overflow
 
+  first_play=true
+  erasable_line=false
+  escape_char=$(printf "\u1b")
+  scrolled=999 # more than any $LINES
   ### begin arg processing ###
   random=false
+  repeat1=false
+  new_random=false
   case $1 in
     -r)
       random=true
       shift
       ;;
+    -s)
+      random=false
+      shift
+      ;;
+    -x)
+      new_random=true
+      shift
+      ;;
   esac
   if (( ! $# )); then
     echo beetag: error expected a query arg >&2
@@ -574,17 +769,9 @@ beetag() {
   volume=70
   read_wait=2
   doplay=true
-  # because we were destined to run out of single key buttons.
-  rare_genres=(
-    jazz
-    musical
-    noise
-    skit
-    spoken-w
-  )
 
   last_genre_i=$(( ${#common_genres[@]} - 1 ))
-  buttons=( {a..p} {r..w} 0 {6..9} , . / )
+  buttons=( {a..p} {r..w} {6..8} , . / - "=")
   button_map=(${common_genres[@]} ${pl_tags[@]})
   fstring=
   for tag in "${pl_tags[@]}"; do
@@ -594,94 +781,207 @@ beetag() {
   for (( i=0; i<${#buttons[@]}; i++ )); do
     button_i[${buttons[i]}]=$i
   done
+
+  # note: this structure of files is rather haphazard.
+  seed_num=1 # later we might want a few
+  seed_file=seed$seed_num
+  if $random; then
+    pl_state_file=$seed_num
+  else
+    pl_state_file=sorted
+  fi
+  pl_state_dir=/i/info/pl-state
+  if [[ $playlist ]]; then
+    pl_state_dir=$pl_state_dir/$playlist
+  else
+    pl_state_dir=$pl_state_dir/nopl
+  fi
+  pl_state_path=$pl_state_dir/$pl_state_file
+  pl_seed_path=$pl_state_dir/$seed_file
+
+
+  if $new_random || [[ ! -r $pl_seed_path ]]; then
+    mkdir -p $pl_state_dir
+    { base64 < /dev/urandom | head -c 200 ||:; echo; } > $pl_seed_path
+  fi
+
+  # PijokVipiotOzeph is just a random string for a delimiter
+  # shellcheck disable=SC2016 # false positive
+  fmt='%ifdef{rating,$rating }'"$fstring"'$genre | $title - $artist - $album   $length  $id PijokVipiotOzeph $path'
   # shellcheck disable=SC2016 # obvious reason
-  beet ls -f '%ifdef{rating,$rating }'"$fstring"', $genre $artist - $album - $title' "$@" | head -n 100 ||:
-  # shellcheck disable=SC2016 # obvious reason
-  mapfile -t ids < <(beet ls -f '$id' "$@" | { if $random; then sort -R; else cat; fi; } )
-  for (( j=0; j<${#ids[@]}; j++ )); do
-    hr
+  tmpstr=$(beet ls -f "$fmt" "$@" | { if $random; then sort -R --random-source=$pl_seed_path; else cat; fi; } )
+  mapfile -t initial_ls <<<"$tmpstr"
+  if [[ ! ${initial_ls[0]} ]]; then
+    echo "beetag: error: no result from beet ls $*"
+    return 1
+  fi
+  id_count=${#initial_ls[@]}
+  for line in "${initial_ls[@]}"; do
+    path="${line#*PijokVipiotOzeph }"
+    # https://github.com/koalaman/shellcheck/issues/2171
+    # shellcheck disable=SC2190 # bug in shellcheck, looking at paths from an earlier function
+    paths+=("$path")
+    line_no_path="${line% PijokVipiotOzeph*}"
+    id="${line_no_path##* }"
+    ids+=("$id")
+    right_pad="${line_no_path%% |*}"
+    ls_line="$(printf %-11s "$right_pad")${line_no_path#"$right_pad"}"
+    ls_lines+=("$ls_line")
+    i=$(( i+1 ))
+  done
+
+
+
+
+  j=0
+  if [[ $playlist ]]; then
+    if [[ -r $pl_state_path ]]; then
+      j=$(cat $pl_state_path)
+    fi
+  fi
+
+  # i only care to see a smallish portion of the list when starting.
+  head_count=$(( LINES - 20 ))
+  head_start=$(( j - head_count / 2 ))
+  if (( head_start < 0 )); then
+    head_start=0
+  fi
+  for (( i=head_start; i < head_count && i < id_count; i++ )); do
+    ls_line="${ls_lines[$i]}"
+    if (( i == j )); then
+      echo "* $ls_line"
+    else
+      echo "$ls_line"
+    fi
+  done
+  if $doplay; then
+    #{ mpv --profile=a --volume=$volume --idle 2>&1 & } 2>/dev/null
+    mpv --profile=a --volume=$volume --idle &
+    # if we dont sleep, can expect an error like this:
+    # socat[1103381] E connect(5, AF=1 "/tmp/mpvsock", 14): Connection refused
+    sleep .1
+  fi
+
+  while true; do
     id=${ids[j]}
-    # shellcheck disable=SC2016 # obvious reason
-    lsout="$(beet ls -f '%ifdef{rating,$rating }'"$fstring"', $genre $id $artist - $album - $title' "id:$id")"
+    path="${paths[$j]}"
+    lsout="${ls_lines[j]}"
     tags=( ${lsout%%,*} )
-    printf "%s\n" "$lsout"
-    for (( i=0; i<${#button_map[@]}; i++)); do
-      if (( i % 3 == 2 )); then
-        printf "%s %s\n" ${buttons[i]} ${button_map[i]}
+    beetag-help
+    printf "██ %s\n" "$lsout"
+    beetag-nostatus 1
+    if $doplay; then
+      # https://stackoverflow.com/a/7687716
+      # note: duplicated down below
+      #
+      # notes on old method of invoking mpv each time:
+      # https://superuser.com/questions/305933/preventing-bash-from-displaying-done-when-a-background-command-finishes-execut
+      # we can't disown or run in a subshell or set +m because all that
+      # disabled job control from working properly in ways we want.
+      # todo: figure out some kind of answer to this. I think the solution
+      # is that we are waiting in 2 second intervals and checking if the
+      # background job exists. Instead, we should make mpv just idle
+      # when it is done with a song and then send it a command to play a new track.
+      #{ mpv --profile=a --volume=$volume "$path" 2>&1 & } 2>/dev/null
+      # old
+      #{ beet play "--args=--volume=$volume" "id:$id" 2>&1 & } 2>/dev/null
+
+      # on slow systems, we may need to wait like .3 seconds before mpv
+      # is ready. so impatiently check until it is ready
+      if $first_play; then
+        first_play=false
+        for (( i=0; i<20; i++ )); do
+          if [[ $(mpvrpco '{ "command": ["get_property", "idle-active"] }' 2>/dev/null | jq .data) == true ]]; then
+            mpvrpc '{ "command": ["loadfile", "'"$path"'"] }' 2>/dev/null
+            break
+          fi
+          sleep .1
+        done
       else
-        printf "%s %-15s" ${buttons[i]} ${button_map[i]}
+        mpvrpc '{ "command": ["loadfile", "'"$path"'"] }'
       fi
-    done
-    if $doplay; then
-      beet play --args=--volume=$volume "id:$id" &
+      erasable_line=false
     fi
     while true; do
       char=
       if $doplay; then
         ret=0
-        read -r -N 1 -s -t $read_wait char || ret=$?
+        read -rsN1 -t $read_wait char || ret=$?
         read_wait=2
         # Automatically skip to the next song if this one ends, unless
         # we turn off the autoplay.
         if (( ret == 142 )) || [[ ! $char ]]; then
-          if bg %% &>/dev/null; then
+          if jobs -p | grep -q . &>/dev/null && \
+              [[ $(mpvrpco '{ "command": ["get_property", "idle-active"] }' | jq .data) == false ]]; then
             continue
           else
             break
           fi
         fi
       else
-        read -r -N 1 -s char
+        read -rsN1 char
       fi
+      beetag-help
       if [[ $char == $'\n' ]]; then
-        kill %% ||: &>/dev/null
         break
       fi
       case $char in
         ";")
-          kill %% ||: &>/dev/null
           j=$(( j - 2 ))
           break
           ;;
         "'")
           if $doplay; then
+            echo "play toggled off"
             doplay=false
           else
             doplay=true
-            kill %% ||: &>/dev/null
-            beet play --args=--volume=$volume "id:$id" &
+            mpvrpc '{ "command": ["loadfile", "'"$path"'"] }'
+            erasable_line=false
           fi
+          beetag-nostatus 1
           continue
           ;;
         _)
-          kill %% ||: &>/dev/null
           m beet rm --delete --force "id:$id"
+          beetag-nostatus 4 # guessing. dont want to test atm
           break
           ;;
         [1-5])
-          beet modify -y "id:$id" rating=$char
+          beetmq "id:$id" rating=$char
           continue
           ;;
-        -)
+        9)
           volume=$(( volume - 5 ))
           if (( volume < 0 )); then
             volume=0
           fi
-          echo volume=$volume
-          continue
-          ;;
-        q)
-          kill %% ||: &>/dev/null
-          return
-          ;;
-        +)
+          ;;&
+        0)
           volume+=5
           if (( volume > 130 )); then
             volume=130
           fi
+          ;;&
+        0|9)
+          mpvrpc '{ "command": ["set_property", "volume", '$volume'] }'
+          beetag-status
           echo volume=$volume
           continue
           ;;
+        ']')
+          if $repeat1; then
+            repeat1=false
+          else
+            repeat1=true
+          fi
+          echo repeat1=$repeat1
+          continue
+          ;;
+        q)
+          kill-bg-quiet
+          return
+          ;;
         y)
           if $do_rare_genres; then
             do_rare_genres=false
@@ -702,6 +1002,7 @@ beetag() {
           continue
           ;;
         z)
+          beetag-nostatus 3
           # if we ctrl-z, it will put the whole function into sleep. so
           # basically, we can't return from a foregrounded mpv like we
           # would like to without some strange mechanism I can't think
@@ -713,6 +1014,108 @@ beetag() {
           fi
           continue
           ;;
+
+        #
+        " ")
+          # output time if we aren't already paused
+          if [[ $(mpvrpco '{ "command": ["get_property", "pause"] }' | jq .data) == false ]]; then
+            # minutes/seconds
+            #date -d @"$(mpvrpco '{ "command": ["get_property", "playback-time"] }' | jq .data)" +%M:%S ||:
+            beetag-status
+            mpvrpc-percent-pos
+          fi
+          # originally found this solution, which worked fine.
+          #kill -STOP %% &>/dev/null
+          #
+          mpvrpc '{ "command": ["cycle", "pause"] }'
+          continue
+          ;;
+        "$escape_char")
+          expected_input=true
+          read -rsn2 escaped_input
+          skip_input_regex="^[0-9]+$"
+          case $escaped_input in
+            # up char: show all the songs, use less
+            '[A')
+              skip_start=0
+              skip_lookback=5
+              if (( j - skip_lookback > skip_start )); then
+                skip_start=$(( j - skip_lookback ))
+              fi
+              beetag-nostatus $(( id_count - skip_start - 1 ))
+              {
+                line_int=0
+                for (( i=skip_start; i < id_count; i++ )); do
+                  if (( i == j )); then
+                    echo "  * ${ls_lines[i]}"
+                    continue
+                  fi
+                  echo "$line_int | ${ls_lines[i]}"
+                  line_int+=1
+                done
+              } | less -F
+              ;;
+            # down char
+            '[B')
+              # skip forward, but show the last few songs anyways.
+              skip_start=0
+              skip_lookback=3
+              if (( j - skip_lookback > skip_start )); then
+                skip_start=$(( j - skip_lookback ))
+              fi
+              beetag-nostatus $(( id_count - skip_start - 1 ))
+
+              line_int=0
+              overflow_lines=$LINES
+              for (( i=skip_start; i < overflow_lines - 1 && i < id_count; i++ )); do
+                ls_line="${ls_lines[i]}"
+                overflow=$(( ${#ls_line} / ( COLUMNS - 1 ) ))
+                overflow_lines=$(( overflow_lines - overflow ))
+                if (( i == j )); then
+                  echo "  * $ls_line"
+                  continue
+                fi
+                echo "$line_int | $ls_line"
+                line_int+=1
+              done
+              ;;
+            # left key
+            '[D')
+              seek_sec=-8
+              ;;&
+            # right key
+            '[C')
+              seek_sec=8
+              ;;&
+            '[C'|'[D')
+              beetag-status
+              mpvrpc-percent-pos
+              erasable_line=true
+              mpvrpc '{ "command": ["seek", "'$seek_sec'"] }'
+              continue
+              ;;
+            *)
+              expected_input=false
+              ;;
+          esac
+          if $expected_input; then
+            read -r skip_input
+            case $skip_input in
+              q)
+                kill-bg-quiet
+                return
+                ;;
+            esac
+            if [[ $skip_input =~ $skip_input_regex ]]; then
+              pre_j_count=$(( j - skip_start ))
+              j=$(( j + skip_input - pre_j_count ))
+              if (( skip_input < pre_j_count )); then
+                j=$(( j - 1 ))
+              fi
+            fi
+            break
+          fi
+          ;;
       esac
       char_i=${button_i[$char]}
       new_item=${button_map[$char_i]}
@@ -721,7 +1124,7 @@ beetag() {
         continue
       fi
       if (( char_i <= last_genre_i )); then
-        m beet modify -y "id:$id" genre=$new_item
+        m beetmq "id:$id" genre=$new_item
       else
         remove=false
         tmp_tags=()
@@ -734,13 +1137,23 @@ beetag() {
         done
         if $remove; then
           tags=("${tags[@]}")
-          m beet modify -y "id:$id" "$new_item!"
+          m beetmq "id:$id" "$new_item!"
         else
           tags+=("$new_item")
-          m beet modify -y "id:$id" $new_item=t
+          m beetmq "id:$id" $new_item=t
         fi
       fi
     done
+    if ! $repeat1; then
+      if (( j < id_count - 1 )); then
+        j+=1
+      else
+        j=0
+      fi
+    fi
+    if [[ $playlist ]]; then
+      echo $j >$pl_state_path
+    fi
   done
 }
 
@@ -776,6 +1189,8 @@ beet2nav() {
 
 # pull in beets library locally
 beetpull() {
+  local sshfs_host
+  sshfs_host=b8.nz
   if [[ $HOSTNAME == kd ]]; then
     return 0
   fi
@@ -784,7 +1199,7 @@ beetpull() {
     s chown iank:iank /i
   fi
   if ! mountpoint /i &>/dev/null; then
-    m sshfs b8.nz:/i /i
+    m sshfs $sshfs_host:/i /i
   fi
 }
 
@@ -864,6 +1279,109 @@ beegenre() {
   rm $tmpf
 }
 
+# prettify the date
+btrbk-date() {
+  local indate
+  indate="$1"
+  shift
+  date +%F_%T%:::z -d "$(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<"$indate")" "$@"
+}
+btrbk-undate() {
+  # fudCaHougfirp is a random string
+  { if [[ $1 ]]; then
+      echo "$1"
+    else
+      cat
+    fi
+  } | sed -r 's/-0([45])( |$)/fudCaHougfirp0\100/;s/_/T/;s/[:-]//g;s/fudCaHougfirp/-/'
+
+}
+btrbk-date-sed() {
+  local line
+  while read -r line; do
+    if [[ $line == *20[0-9][0-9][0-9][0-9][0-9][0-9]T[0-9][0-9][0-9][0-9][0-9][0-9]-0[45]00* ]]; then
+      pre="${line%%20[0-9][0-9][0-9][0-9][0-9][0-9]T[0-9][0-9][0-9][0-9][0-9][0-9]-0[45]00*}"
+      post="${line##*20[0-9][0-9][0-9][0-9][0-9][0-9]T[0-9][0-9][0-9][0-9][0-9][0-9]-0[45]00}"
+      mid="${line:${#pre}:22}"
+      echo "$pre$(btrbk-date "$mid")$post"
+    else
+      echo "$line"
+    fi
+  done
+}
+jrbtrbk() {
+  jr -u btrbk-run -u btrbk -u switch-mail-host "$@"
+}
+
+# internal function
+btrbk-host-debug-show-host() {
+  for f; do
+    snaphost=
+    for host in $remote $alt local; do
+      if line=$(grep -P "\S*$f" /tmp/b/s/$host.log); then
+        if [[ $snaphost ]]; then
+          e error: snaphost=$snaphost, host=$host line="$line"
+        fi
+        if [[ $line == ssh* ]]; then
+          tmp="${line#ssh://}"
+          snaphost="${tmp%%/*}"
+        else
+          snaphost=$host
+        fi
+      fi
+    done
+    echo $snaphost $f | btrbk-date-sed
+  done
+}
+
+# If we get a btrfs receive error like this:
+# ERROR: ... clone: did not find source subvol
+# running this command will help track down the problem.
+# Alter remote= and alt=. When I used it, remote is
+# the host having the error when I push a snapshot.
+# Alt is just the other host that takes snapshots
+# besides the local host.
+btrbk-host-debug() {
+
+  remote=b8.nz
+  alt=sywg.b8.nz
+
+  mkdir -p /tmp/b/s
+  for host in $remote $alt; do
+    h=$(ssh $host hostname)
+    rsync -a /var/log/btrbk $host:/var/log/btrbk /var/log/btrbk/$h
+    grr '\bsnapshot success' /var/log/btrbk/$h >/tmp/b/$h.log
+
+    ## this takes a while, we only want to do it on 1st run
+    # if [[ -s /tmp/b/$host.log ]]; then continue; fi
+    # ssh $host journalctl -u btrbk-run -u btrbk -u switch-mail-host >/tmp/b/$host.log
+  done
+  gr '\bsnapshot success' /var/log/btrbk/*.log >/tmp/b/local.log
+  cd /tmp/b
+  for f in *.log; do
+    gr '\bsnapshot success' $f >s/$f
+  done
+  cd /mnt/root/btrbk
+  localq=(q.*)
+  declare -A localq_a
+  for f in "${localq[@]}"; do
+    localq_a[$f]=t
+  done
+
+  remoteq=()
+  for f in $(ssh $remote "cd /mnt/root/btrbk; echo q.*"); do
+    if [[ ! ${localq_a[$f]} ]]; then
+      remoteq+=($f)
+    fi
+  done
+  btrbk-host-debug-show-host "${localq[@]}"
+  if (( ${#remoteq[@]} >= 1 )); then
+    echo "=== $remote only ===="
+    btrbk-host-debug-show-host ${remoteq[@]}
+  fi
+
+}
+
 # note, to check for glue records
 # First, find some the .org nameservers:
 # dig +trace iankelling.org
@@ -894,8 +1412,6 @@ bbk() { # btrbk wrapper
       return 1
       ;;
   esac
-  # run latest
-  install-my-scripts
   # todo: consider changing this to srun and having the args come
   # from a file like /etc/default/btrbk, like is done in exim
   s jdo btrbk-run "$@"
@@ -949,14 +1465,16 @@ scr() {
 # tried to use ceb2txt but it failed because of schema
 # slightly different than what it expected.
 cheogram-get-logs() {
-  adb shell rm -r /storage/emulated/0/Download/Cheogram/Backup
+  #adb shell rm -r /storage/emulated/0/Download/Cheogram/Backup
   read -r -p "do cheogram backup on phone, do not enable extra cheogram data. press any key when done"
   cd /p/cheogram
   rm -rf Backup b
   adb pull /storage/emulated/0/Download/Cheogram/Backup
   sqlite3 b </a/opt/ceb-tools/schema.sql
   echo "note: the next step took 39 seconds last time i measured"
-  /a/opt/ceb-tools/ceb2sqlgz Backup/iank@fsf.org.ceb <pas | gunzip | sqlite3 b
+  # expected failure: Error: near line 1: in prepare, table accounts has no column named pinned_mechanism (1)
+  # the sql needs an update
+  /a/opt/ceb-tools/ceb2sqlgz Backup/iank@fsf.org.ceb <pas | gunzip | sqlite3 b ||:
   rm -r Backup
 }
 
@@ -980,9 +1498,17 @@ order by timeSent;"
 mycheologs() {
   local days q
   days=${1:-16}
+  # timezone compared to utc. note: this takes the current offset, so if daylight savings change
+  # happened in the looking back period, this won't account for it.
+  zone_offset=$(( $( date +%z | sed 's/[^1-9-]*//g' ) * 60 * 60))
+  case $zone_offset in
+    -*) : ;;
+    *) zone_offset="+ $zone_offset"
+  esac
+  echo zone_offset=$zone_offset
   q="
 select
- datetime(substr(timeSent,0,11),  'unixepoch'),
+ datetime(substr(timeSent,0,11) $zone_offset,  'unixepoch'),
  body
 from messages
 where timeSent > $(( (EPOCHSECONDS - days * 60 * 60 * 24) * 1000 ))
@@ -1088,11 +1614,10 @@ sm() { # switch mail host
   c /
   # run latest
   keyhash=$(s ssh-keygen -lf /root/.ssh/home  | awk '{print $2}')
-  tmp=$(s ssh-add -l | awk '$2 == "'$keyhash'"')
+  tmp=$(s ssh-add -l | awk '$2 == "'$keyhash'"' ||:)
   if [[ ! $tmp ]]; then
     s ssh-add /root/.ssh/home
   fi
-  install-my-scripts
   s jdo switch-mail-host "$@"
   return $ret
 }
@@ -1117,7 +1642,7 @@ lipush() {
   local p a
   # excluding emacs for now
   #p=(/a/opt/{emacs-debian11{,-nox},mu,emacs} /a/bin /a/exe /a/h /a/c /p/c/machine_specific/vps{,.hosts})
-  p=(/a/bin /a/exe /a/h /a/c /p/c/machine_specific/vps{,.hosts})
+  p=(/a/bin /a/exe /a/h /a/c /p/c/machine_specific/vps{,.hosts} /c/roles/prom_export/files/simple/usr/local/bin/fsf-install-node-exporter)
   a="-ahviSAXPH --specials --devices --delete --relative --exclude-from=/p/c/li-rsync-excludes"
   ret=0
   for h in li je bk; do
@@ -1130,14 +1655,14 @@ lipush() {
   return $ret
 }
 bkpush() { # no emacs. for running faster.
-  p=(/a/bin /a/exe /a/h /a/c /p/c/machine_specific/vps{,.hosts})
+  p=(/a/bin /a/exe /a/h /a/c /p/c/machine_specific/vps{,.hosts} /c/roles/prom_export/files/simple/usr/local/bin/fsf-install-node-exporter)
   a="-ahviSAXPH --specials --devices --delete --relative --exclude-from=/p/c/li-rsync-excludes"
   ret=0
   m rsync "$@" $a ${p[@]} /p/c/machine_specific/bk root@bk.b8.nz:/ || ret=$?
   return $ret
 }
 jepush() { # no emacs. for running faster.
-  p=(/a/bin /a/exe /a/h /a/c /p/c/machine_specific/vps{,.hosts})
+  p=(/a/bin /a/exe /a/h /a/c /p/c/machine_specific/vps{,.hosts} /c/roles/prom_export/files/simple/usr/local/bin/fsf-install-node-exporter)
   a="-ahviSAXPH --specials --devices --delete --relative --exclude-from=/p/c/li-rsync-excludes"
   ret=0
   m rsync "$@" $a ${p[@]} /p/c/machine_specific/je root@je.b8.nz:/ || ret=$?
@@ -1148,7 +1673,7 @@ bindpush() {
   dsign iankelling.org expertpathologyreview.com zroe.org amnimal.ninja
   lipush
   for h in li bk; do
-    m sl $h <<'EOF'
+    m sl $h.b8.nz <<'EOF'
 source ~/.bashrc
 m dnsup
 EOF
@@ -1213,6 +1738,15 @@ dsign() {
   done
 }
 
+# set day start for use in other programs.
+# expected to do be in a format like 830, or 800 or 1300.
+ds() {
+  if [[ $1 ]]; then
+    echo $1 >/b/data/daystart
+  else
+    cat /b/data/daystart
+  fi
+}
 
 #### begin bitcoin related things
 btc() {
@@ -1584,7 +2118,7 @@ rename-test() {
 
 feh() {
   # F = fullscren, z = random, Z = auto zoom
-  command feh -FzZ "$@"
+  command feh --auto-rotate -FzZ "$@"
 }
 
 
@@ -1635,7 +2169,7 @@ hstatus() {
 wlog() {
   local day i days_back
   days_back=${1:-16}
-  for (( i=0; i<days_back; i++ )); do
+  for (( i=days_back; i>=0; i-- )); do
     day=$( date +%F -d @$((EPOCHSECONDS - 86400*i )) )
     date "+%a %b %d" -d @$((EPOCHSECONDS - 86400*i )) | tr '\n' ' '
     /a/opt/timetrap/bin/t d -ftotal -s $day -e $day all -m '^w|lunch$'
@@ -1653,26 +2187,87 @@ tl() {
   t s w
 }
 
-arbttlog() { arbtt-dump "$@" | grep -v '( )\|Current Desktop' | sed -rn '/^[^ ]/{N;s/^(.{21})([0-9]*)[0-9]{3}m.*\(\*/\1\2/;s/^(.{21})[0-9]*.*\(\*/\1/;s/\n//;p}' ;   }
+focus() {
+  /p/c/proc/focus/linux-amd64/focus &
+  watcharb5
+  kill %%
+}
+
+
+watcharb5() {
+  local char ret
+  killall arbtt-capture ||:
+  rm -f ~/.arbtt/capture.log
+  arbtt-capture --sample-rate=10 &
+  clear
+  while true; do
+    arb5
+    ret=0
+    # i first thought to sleep and capture ctrl-c, but it seems we can't
+    # capture control-c, unless maybe we implement the commands in a
+    # separate script or maybe add err-cleanup to err. Anyways, this
+    # method is superior because any single char exits.
+    read -rsN1 -t 5 char || ret=$?
+    if (( ret == 142 )) || [[ ! $char ]]; then
+      # debug
+      #e ret=$ret char=$char
+      :
+    else
+      killall arbtt-capture ||:
+      return 0
+    fi
+    clear
+  done
+
+}
+
+arb5() {
+  local i l sec
+  i=0
+  if [[ ! -e ~/.arbtt/capture.log ]]; then
+    sleep 5
+  fi
+  # https://stackoverflow.com/questions/56486272/how-to-concat-multiple-fields-to-same-line-with-jq
+  arbtt-dump -l 30 -t json | jq -r '.[] | [ ( .inactive  / 1000 | floor ) , ( .windows[] | select (.active == true) |.title) ] | @tsv' \
+    | tac | while read -r sec l; do
+    if (( i % 6 == 0 && i >= 2 )); then
+      echo "## $(( i / 6 + 1 )) ##"
+    fi
+    if (( sec > 10 )); then
+      printf "%3d %s\n" $sec "$l"
+    else
+      printf "    %s\n" "$l"
+    fi
+    i=$(( i + 1 ))
+  done
+}
+
+arbttlog() {
+  # from the log, show only the currently active window, and the number of
+  # seconds of input inactivity.
+  arbtt-dump "$@" | grep -v '( )\|Current Desktop' | sed -rn '/^[^ ]/{N;s/^(.{21})([0-9]*)[0-9]{3}m.*\(\*/\1\2/;s/^(.{21})[0-9]*.*\(\*/\1/;s/\n//;p}' ;   }
 
 idea() {
   /a/opt/idea-IC-163.7743.44/bin/idea.sh "$@" & r
 }
 
 ilogs-local() {
-  cd /var/lib/znc/moddata/log/iank/freenode/
-  hr
-  for x in "#$1/"*; do
-    base=${x##*/}
-    files=()
-    for f in $@; do
-      tmp=\#$f/$base
-      if [[ -e $tmp ]]; then
-        files+=(\#$f/$base)
-      fi
-    done
-    sed \"s/^./${base%log}/\" ${files[@]}|sort -n
+  d=/var/lib/znc/moddata/log/iank/
+  for n in freenode libera; do
+    cd $d/$n
     hr
+    for x in "#$1/"*; do
+      base=${x##*/}
+      files=()
+      for f in $@; do
+        tmp=\#$f/$base
+        if [[ -e $tmp ]]; then
+          files+=(\#$f/$base)
+        fi
+      done
+      sed \"s/^./${base%log}/\" ${files[@]}|sort -n
+      hr
+    done
   done
 }
 ilogs() {
@@ -1685,7 +2280,11 @@ ilog-local() {
   chan="$1"
   d=/var/lib/znc/moddata/log/iank/
   for n in freenode libera; do
-    cd $d$n/"$chan" && hr
+    if [[ ! -d $d$n/"$chan" ]]; then
+      continue
+    fi
+    cd $d$n/"$chan"
+    hr
     for x in *; do
       echo $x; sed "s/^./${x%log}/" $x; hr;
     done
@@ -1720,11 +2319,6 @@ ccomp xdg-open o
 # jr() { journalctl "$@" | jfilter | less ; }
 # jrf() { journalctl -n 200 -f "$@" | jfilter; }
 
-jr() { journalctl "$@" ; }
-jrf() { journalctl -n 200 -f "$@" ; }
-
-
-ccomp journalctl jtail jr jrf
 
 ## old version for model01. i need to get that firmware working again.
 # kff() { # keyboardio firmware flash. you must hold down the tilde key
@@ -1754,20 +2348,145 @@ wgkey() {
   wg genkey | tee $name-priv.key | wg pubkey > $name-pub.key
   umask $umask_orig
 }
+
+declare -A vpn_ips
+vpn_ips[kd]=2
+# note: 1, 4, 5 are occupied by mail wireguard
+vpn_ips[x3]=8
+vpn_ips[sy]=12
+vpn_ips[x2]=13
+vpn_ips[kw]=27
+vpn_ips[bo]=28
+vpn_ips[frodo]=34
+
+vpn-ips-update() {
+  local host ipsuf f files
+  for host in ${!vpn_ips[@]}; do
+    ipsuf=${vpn_ips[$host]}
+    wghole $host $ipsuf
+    u /a/bin/ds/machine_specific/$host/filesystem/etc/systemd/system/openvpn-client-tr@.service <<EOF
+[Unit]
+Description=OpenVPN tunnel for %I
+After=syslog.target network-online.target
+Wants=network-online.target
+Documentation=man:openvpn(8)
+Documentation=https://community.openvpn.net/openvpn/wiki/Openvpn24ManPage
+Documentation=https://community.openvpn.net/openvpn/wiki/HOWTO
+Requires=iptables.service
+
+[Service]
+Type=notify
+RuntimeDirectory=openvpn-client
+RuntimeDirectoryMode=0710
+WorkingDirectory=/etc/openvpn/client
+ExecStart=/usr/sbin/openvpn --suppress-timestamps --nobind --config /etc/openvpn/client/%i.conf
+# todo, try reenabling this from the default openvpn,
+# it was disabled so we could do bind mounts as a command,
+# but now systemd handles it
+#CapabilityBoundingSet=CAP_IPC_LOCK CAP_NET_ADMIN CAP_NET_RAW CAP_SETGID CAP_SETUID CAP_SYS_CHROOT CAP_DAC_OVERRIDE
+LimitNPROC=10
+# DeviceAllow=/dev/null rw
+# DeviceAllow=/dev/net/tun rw
+
+# we use .1 to make this be on a different network than kd, so that we can
+# talk to transmission on kd from remote host, and still use this
+# vpn.
+ExecStartPre=/usr/bin/flock -w 20 /tmp/newns.flock /a/bin/newns/newns -n 10.174.$ipsuf start %i
+ExecStartPre=/sbin/iptables-restore /a/bin/distro-setup/transmission-firewall/netns.rules
+# allow wireguard network to connect
+ExecStartPre=/usr/sbin/ip r add 10.8.0.0/24 via 10.174.$ipsuf.1 dev veth1-client
+ExecStopPost=/usr/bin/flock -w 20 /tmp/newns.flock /a/bin/newns/newns stop %i
+PrivateNetwork=true
+BindReadOnlyPaths=/etc/tr-resolv:/run/systemd/resolve:norbind /etc/basic-nsswitch:/etc/resolved-nsswitch:norbind
+
+[Install]
+WantedBy=multi-user.target
+EOF
+  done
+
+  {
+    for host in ${!vpn_ips[@]}; do
+      ipsuf=${vpn_ips[$host]}
+      cat <<EOF
+local-data-ptr: "10.2.0.$ipsuf $host.b8.nz"
+EOF
+    done
+  } | u /b/ds/ptr-data
+
+  {
+    for host in ${!vpn_ips[@]}; do
+      ipsuf=${vpn_ips[$host]}
+      cat <<EOF
+$host  A       10.2.0.$ipsuf
+${host}wg      A       10.8.0.$ipsuf
+${host}vp      A       10.5.5.$ipsuf
+${host}tr      A       10.174.$ipsuf.2
+EOF
+    done
+  } | cedit vpn-ips-update /p/c/machine_specific/vps/bind-initial/db.b8.nz ||:
+
+
+  echo checking for stray files:
+
+  initial_dir=$PWD
+  cd /a/bin/ds/machine_specific
+  ngset
+  files=( */filesystem/etc/systemd/system/openvpn-client-tr@.service )
+  ngreset
+  cd $initial_dir
+  for f in "${files[@]}"; do
+    host=${f%%/*}
+    if [[ ! ${vpn_ips[$host]} ]]; then
+      e /a/bin/ds/machine_specific/$host/filesystem/etc/systemd/system/openvpn-client-tr@.service
+    fi
+  done
+
+  cd /p/c/machine_specific
+  ngset
+  files=( */filesystem/etc/wireguard/wghole.conf )
+  ngreset
+  cd $initial_dir
+  for f in "${files[@]}"; do
+    host=${f%%/*}
+    if [[ ! ${vpn_ips[$host]} ]]; then
+      e /p/c/machine_specific/$host/filesystem/etc/wireguard/wghole.conf
+      e cedit -s $host /p/c/machine_specific/li/filesystem/etc/wireguard/wgmail.conf '<<<""'
+    fi
+  done
+}
+
+# usage host ipsuf [extrahost]
+#
+# If the keys already exist and you want new ones, remove them:
+# rm /p/c/machine_specific/$host/filesystem/etc/wireguard/hole-{priv,pub}.key
+#
+# extrahost is a host/cidr that is allowed to go be routed through the
+# vpn by this host.
 wghole() {
-  if (( $# != 2 )); then
-    e expected 2 arg of hostname, ip suffix >&2
+  if (( $# < 2 || $# > 3 )); then
+    e expected 2-3 arg of hostname, ip suffix, and extrahost >&2
     return 1
   fi
-  local host ipsuf umask_orig
+  local host ipsuf umask_orig vpn_allowed
   host=$1
   ipsuf=$2
+  if [[ $3 ]]; then
+    extrahost=,$3
+  fi
+  for vpn_host in ${!vpn_ips[@]}; do
+    if [[ $vpn_host == "$host" ]]; then
+      continue
+    fi
+    vpn_allowed+=",10.174.${vpn_ips[$vpn_host]}.2/32"
+  done
   mkdir -p /p/c/machine_specific/$host/filesystem/etc/wireguard
   (
     cd /p/c/machine_specific/$host/filesystem/etc/wireguard
     umask_orig=$(umask)
     umask 0077
-    wg genkey | tee hole-priv.key | wg pubkey > hole-pub.key
+    if [[ ! -s hole-priv.key || ! -s hole-pub.key ]]; then
+      wg genkey | tee hole-priv.key | wg pubkey > hole-pub.key
+    fi
     cat >wghole.conf <<EOF
 [Interface]
 # contents hole-priv.key
@@ -1776,12 +2495,12 @@ ListenPort = 1194
 Address = 10.8.0.$ipsuf/24
 # https://dev.to/tangramvision/what-they-don-t-tell-you-about-setting-up-a-wireguard-vpn-1h2g
 # ||: makes the systemd service not fail due to the failed command
-PostUp = ping -c1 10.8.0.1 ||:
+PostUp = ping -w10 -c1 10.8.0.1 ||:
 
 [Peer]
 # li. called wgmail on that server
 PublicKey = CTFsje45qLAU44AbX71Vo+xFJ6rt7Cu6+vdMGyWjBjU=
-AllowedIPs = 10.8.0.0/24
+AllowedIPs = 10.8.0.0/24$vpn_allowed$extrahost
 Endpoint = 72.14.176.105:1194
 PersistentKeepalive = 25
 EOF
@@ -1791,7 +2510,7 @@ EOF
     cedit -q $host /p/c/machine_specific/li/filesystem/etc/wireguard/wgmail.conf <<EOF || [[ $? == 1 ]]
 [Peer]
 PublicKey = $(cat hole-pub.key)
-AllowedIPs = 10.8.0.$ipsuf/32
+AllowedIPs = 10.8.0.$ipsuf/32,10.174.${vpn_ips[$host]}.2/32
 EOF
   )
 }
@@ -1834,6 +2553,10 @@ mnsnonet() {
 lom() {
   # l = the loopback device
   local l base
+  # get sudo pass cached right away
+  if ! sudo -nv 2>/dev/null; then
+    sudo -v
+  fi
   if [[ $1 == /* ]]; then
     base=${1##*/}
     fs_file=$1
@@ -2048,13 +2771,29 @@ mpvs() {
 
 myirc() {
   if [[ ! $1 ]]; then
-    set -- fsf-office
+    set -- fsfsys
   fi
   local -a d
   d=( /var/lib/znc/moddata/log/iank/{freenode,libera} )
   # use * instead of -r since that does sorted order
   ssh root@iankelling.org "for f in ${d[*]}; do cd \$f/#$1; grep '\<iank.*' *; done" | cut --complement -c12-16
 }
+
+
+allmyirc() {
+  local d
+  d=/var/lib/znc/moddata/log/iank/freenode
+  ssh root@iankelling.org "cd $d; find . -mtime -60 -type f -exec grep '\<iank.*' {} +" | sed -r 's,^..([^/]*)/(.{11})(.{5})(.{8}).,\2\4 \1,' | sort
+}
+
+# The way pidgin logs with xmpp (maybe related to running cheogram too)
+# is that there are sometimes duplicates, and sometimes the a log file
+# is for a specific day yet logs messages for subsequent days, and the
+# only way to realize that is to notice that the timestamps rolled over
+# into a new day, you can't see it in isolation. So, basically, pidgin
+# logs are really annoying to read a grep of my messages to find the
+# date and time I said when I started and stopped working, so I'm trying
+# out a new client: profanity.
 mypidgin() {
   c /p/c/.purple/logs/jabber/iank@fsf.org/office@conference.fsf.org.chat
   for x in *.html; do html2text -o ${x%.html}.txt $x; done;
@@ -2066,12 +2805,54 @@ s/^[^ ]*\.txt-//
 s/^[^ ]*\.txt:\((.{2}).(.{2}).(.{4}) (.{8}) (.{2})\)?/\3-\1-\2_\4_\5/' \
     | sed -n 'x;1d;0~2{G;s/\n/ /;p};${x;p}'
 }
-allmyirc() {
-  local d
-  d=/var/lib/znc/moddata/log/iank/freenode
-  ssh root@iankelling.org "cd $d; find . -mtime -60 -type f -exec grep '\<iank.*' {} +" | sed -r 's,^..([^/]*)/(.{11})(.{5})(.{8}).,\2\4 \1,' | sort
+
+# my profanity
+#
+myprof() {
+  pushd /home/iank/.local/share/profanity/chatlogs/iank_at_fsf.org/rooms/office_at_conference.fsf.org
+  logs=(*)
+  logcount=${#logs[@]}
+  if (( logcount > 15 )); then
+    i=$(( logcount - 15 ))
+  else
+    i=0
+  fi
+  min_date=$(date -d 'monday 2 weeks ago' +%s)
+  for (( ; i < logcount; i++ )); do
+    log=${logs[$i]}
+    d=$(date -d "$(head -n1 $log|awk '{print $1}')" +%s)
+    if (( d < min_date )); then
+      continue
+    fi
+    if awk '$3 == "iank:"' $log | sed -r 's/^(.{10}).(.{8})[^ ]+(.*)/\1_\2\3/' | grep .; then
+      hr
+    fi
+  done
+  popd
+}
+
+# tail pms in the last day, for the case where we restart profanity and
+# didn't check for pms beforehand.
+profrecent() {
+  local d dates date files f
+  # consider making the day count passed by parameter. note: this works: $(date -d '2 day ago' +%Y_%m_%d)
+  dates=("$(date -d +%Y_%m_%d)" "$(date -d '1 day ago' +%Y_%m_%d)" )
+  for d in /d/p/profanity/chatlogs/iank_at_fsf.org/!(rooms); do
+    files=()
+    for date in ${dates[@]}; do
+      f=$d/$date.log
+      if [[ -e $f ]]; then
+        files+=($f)
+      fi
+    done
+    if (( ${#files[@]} >= 1 )); then
+      cat ${files[@]} | tail
+      hr
+    fi
+  done
 }
 
+
 # usage: debvm DEBIAN_VERSION RAM_MB
 debvm() {
   local ver ram fname src
@@ -2164,9 +2945,17 @@ otp() {
   oathtool --totp -b "$*" | xclip -selection clipboard
 }
 j() {
-  "$@" |& pee "xclip -r -selection clipboard"
+  "$@" |& pee "xclip -r -selection clipboard" cat
 }
 
+# x copy
+xc() {
+  xclip -r -selection clipboard
+}
+# echo copy
+ec() {
+  pee "xclip -r -selection clipboard" cat
+}
 
 pakaraoke() {
   # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
@@ -2545,7 +3334,12 @@ tm() {
   (sleep "$(calc "$* * 60")" && mpv --no-config --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
 }
 
+## usage: to connect to my main transmission daemon from a different host, run this
+trans-remote-route() {
+  :
+}
 trg() { transmission-remote-gtk & r; }
+# TODO: this wont work transmission.lan doesnt exist
 trc() {
   # example, set global upload limit to 100 kilobytes:
   # trc -u 100
@@ -2583,7 +3377,7 @@ enn() {
     s $ecmd "$@"
     return
   fi
-  pid=$(pgrep -f "/usr/sbin/exim4 -bd -q30m -C /etc/exim4/my.conf"|h1)
+  pid=$(pgrep -f "/usr/sbin/exim4 -bd -q10m -C /etc/exim4/my.conf"|h1)
   m s nsenter -t $pid -n -m $ecmd "$@"
 }
 
@@ -2662,7 +3456,7 @@ mailnnbash() {
 
 eximbash() {
   local pid
-  pid=$(pgrep -f "/usr/sbin/exim4 -bd -q30m -C /etc/exim4/my.conf"|h1)
+  pid=$(pgrep -f "/usr/sbin/exim4 -bd -q10m -C /etc/exim4/my.conf"|h1)
   if [[ ! $pid ]]; then
     echo "eximbash: failed to find exim pid. systemctl -n 30 status exim4:"
     systemctl status exim4
@@ -2750,6 +3544,17 @@ fixu() {
   fi
 }
 
+# unmute
+um() {
+  pactl set-sink-mute @DEFAULT_SINK@ false
+  rm -f /tmp/ianknap
+}
+nap() {
+  pactl set-sink-mute @DEFAULT_SINK@ true
+  touch /tmp/ianknap
+}
+
+
 # systemctl is-enabled / status / cat says nothing, instead theres
 # some obscure symlink. paths copied from man systemd.unit.
 # possibly also usefull, but incomplete, doesnt show units not loaded in memory:
@@ -2850,6 +3655,26 @@ vspicy() { # usage: VIRSH_DOMAIN
 wian() {
   cat-new-files /m/4e/INBOX/new
 }
+wakehours() {
+  local sec
+  if (( $# != 1 )) ; then
+    echo wakehours: error: expected 1 arg, got $# >&2
+    return 1
+  fi
+  sec=$(( EPOCHSECONDS -  $( date +%s -d $1am ) ))
+  printf "%d:%02d\n" $(( sec / 60 / 60)) $(( (sec / 60) % 60 ))
+}
+
+calvis() { # calendar visualize
+  install -m 600 /dev/null /tmp/calendar-bytes
+  while read -r l; do
+    for char in $l; do
+      # shellcheck disable=SC2059 # intentional for the hex formatting
+      printf "\x$(printf "%x" $char)" >>/tmp/calendar-bytes
+    done
+  done < <(grep -v '[#-]' /p/calendar-data)
+  /p/c/proc/calendar/linux-amd64/calendar
+}
 
 wtr() { curl wttr.in/boston; }
 
@@ -2881,7 +3706,61 @@ monero() {
 
 # rg my main files
 rgm() {
-  rg "$@" /p/pd.org /p/w.org /a/t.org /a/work.org /b
+  rg "$@" /p/w.org /a/t.org /a/work.org /b
+}
+
+# re all my files more expansively
+rem() {
+  local paths
+  paths="/p/c /b"
+  find $paths -not \( -name .svn -prune -o -name .git -prune \
+       -o -name .hg -prune -o -name .editor-backups -prune \
+       -o -name .undo-tree-history -prune \) 2>/dev/null | grep -iP --color=auto -- "$*" ||:
+  rgv -m 5 -- "$*" $paths /a/t.org /p/w.org /a/work.org ||:
+}
+
+# setup:
+# pip3 install linode-cli
+# linode-cli
+livp9() {
+  local input ip id tmp
+  input=$1
+  if [[ $2 ]]; then
+    id=$2
+    ip=$3
+  else
+    tmp=$(mktemp)
+    echo $tmp
+    linode-cli --json --pretty linodes create --root_pass loxHuceygomGisun | tee $tmp
+    read -r ip id <<<"$(tail -n+2 $tmp | jq -r '.[0].ipv4[0] , .[0].id')"
+    for string in $ip $id; do
+      case $string in
+        [0-9]*) : ;;
+        *)
+          echo "livp9: bad value ip=$ip id=$id input=$input"
+          return 1
+          ;;
+      esac
+    done
+    rm $tmp
+
+    while true; do
+      if timeout 4 ssh $ip :; then
+        break
+      fi
+      sleep 3
+    done
+  fi
+  ssh $ip <<EOF
+apt-get -qq update
+apt-get -qq -y install ffmpeg rsync
+mkdir vp9
+EOF
+  m rsync $input $ip:
+  m ssh $ip ffmpeg -nostdin -hide_banner -loglevel error -i $input -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999  -b:v 750K -pass 1 -an -f null /dev/null
+  m ssh $ip ffmpeg -nostdin -hide_banner -loglevel error -y -i $input -g 192 -vcodec libvpx-vp9 -tile-rows 2 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 vp9/$input
+  rsync $ip:vp9/$input vp9
+  linode-cli linodes delete $id
 }
 
 reset-konsole() {
@@ -2992,7 +3871,7 @@ path-add --end $HOME/.cargo/bin
 if type -P rg &>/dev/null; then
   # --no-messages because of annoying errors on broken symlinks
   # -z = search .gz etc files
-  # -. = search dotfilesq
+  # -. = search dotfiles
   rg() { command rg -. -z --no-messages -L -i -M 900 --no-ignore-parent --no-ignore-vcs -g '!.git' -g '!auto-save-list' -g '!.savehist' "$@" || return $?; }
   #fails if not exist. ignore
   complete -r rg 2>/dev/null ||:
@@ -3000,7 +3879,68 @@ else
   alias rg=grr
 fi
 
+# rg with respecting vcs ignore files
+rgv() {
+  ret=0
+  # -. = search dotfiles
+  # -z = search zipped files
+  # -i = case insensitive
+  # -M = max columns
+  # --no-messages because of annoying errors on broken symlinks
+  command rg -. -z --no-messages -i -M 900 -g '!.git' -g '!auto-save-list' -g '!.savehist' "$@" || ret=$?
+  return $ret
+}
+
+amall() {
+  echo "$(tput setaf 5 2>/dev/null ||:)█ coresite █$(tput sgr0 2>/dev/null||:)"
+  amfsf "$@"
+  echo "$(tput setaf 5 2>/dev/null ||:)█ office █$(tput sgr0 2>/dev/null||:)"
+  amoffice "$@"
+}
+amallq() { # amall quiet
+  amfsf "$@"
+  amoffice "$@"
+}
+amfsf() {
+  sedi -r '/alertmanager.url/s/@prom.office/@prom/' ~/.config/amtool/config.yml
+  amtool "$@"
+}
+amoffice() {
+  sedi -r '/alertmanager.url/s/@prom.fsf/@prom.office.fsf/' ~/.config/amtool/config.yml
+  amtool "$@"
+}
+amls() {
+  amall silence query "$@"
+}
+# amtool silence add
+amsa() {
+  amall silence add "$@"
+}
+# amtool silence force
+amsf() {
+  amall silence add x!="1"
+}
+amrmall() {
+  # note: not sure if quoting of this arg is correct
+  amfsf silence expire "$(amfsf silence query -q)"
+  amoffice silence expire "$(amoffice silence query -q)"
+}
+
 
+youtube-dl-update() {
+  sudo wget https://yt-dl.org/downloads/latest/youtube-dl -O /usr/local/bin/youtube-dl
+  sudo chmod a+rx /usr/local/bin/youtube-dl
+}
+
+# https://github.com/yt-dlp/yt-dlp/wiki/Installation
+yt-dlp-update() {
+  sudo curl -L https://github.com/yt-dlp/yt-dlp/releases/latest/download/yt-dlp -o /usr/local/bin/yt-dlp
+  sudo chmod a+rx /usr/local/bin/yt-dlp  # Make executable
+}
+
+mpvyt() {
+  mpv --ytdl ytdl_path=/usr/local/bin/yt-dlp "$@"
+}
 
 # taken from default changes to bashrc and bash_profile
 path-add --end --ifexists $HOME/.rvm/bin